'-------------------------------------------------------------------------------------------

'                   USART  Bascom

'---------------------------   -----------------------------------------
  $regfile = "m8def.dat"
'  $crystal = 1000000       ' 1 
'  $crystal = 8000000        ' 8 
'  $crystal = 7372800       ' 7.372 
'  $crystal = 14745600       ' 14.7456 
'  $crystal = 16000000        ' 16 
  $crystal = 18432000       ' 18.432 
  $framesize = 32
  $hwstack = 40
  $swstack = 16
  $baud = 57600       '1200     '2400     '4800     '9600     '19200     '38400     '57600     '115200

'-------------------   TIMER0  TIMER2     ----------------

  Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear Up , Compare B Pwm = Clear Up , Prescale = 1       '1|8|64|256|1024
  Config Portb.1 = Output
  Config Portb.2 = Output

  Config Timer2 = Pwm , Compare Pwm = Clear Up , Prescale = 1       '1|8|64|256|1024
  Config Portb.3 = Output

'----------------------------   USART  --------------------------------------
'  Config Com1 = 4800 , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0
  Config Pind.0 = Input       '   RxD,  USART
  Config Pind.1 = Output       '   TxD,  USART

  On Urxc __uart       '           UART
  On Udre __uart_       '            UART
'  On Urxc __uart_       '           UART
'  On Utxc __uart_       '           UART
'-----------------------------    LCD   ----------------------------------
  Config Lcdpin = Pin , Rs = Portc.0 , E = Portc.1 , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5
'---------------------------------------
  Config Lcd = 20 * 4       '  LCD
  Initlcd '  LCD
  Waitms 50       '    
  Cursor Off Noblink       '   
'  Cursor On Noblink         '   
'  Cursor On Blink           '   
  Cls     '  ,   
'-------------        LCD   ------------------
  Deflcdchar 0 , 6 , 9 , 9 , 6 , 32 , 32 , 32 , 32       '  
'-------------------------------------------------------------------------------------------

'-----        LCD HD44780  -----
  Declare Sub Lcd_print(byval _lcd_print As String)       '      LCD HD44780
'------------------       -----------------
  Dim _lcd As String * 1 ,  As String * 1 , __lcd As String * 20
  Dim _ As Byte , __lcd As Byte , _lcd As Byte , _lcd As Byte
  Dim  As Integer , _lcd_print As Integer , _lcd As String * 20 , _lcd As Byte
'-------------------------------------------------------------------------------------------

'-----------------------     --------------------------------

  Dim _ As Byte
  Dim __uart_ As Byte
  Dim __uart As String * 20
  Dim __ As String * 1
  Dim __uart As String * 20
  Dim ___ As Byte
  Dim ___uart As Byte
  Dim __ As Byte
  Dim __uart_ As Byte
  Dim ____uart As Byte


'   
  Dim __uart_(21) As Byte At __uart Overlay       '    



'-----------------------     -----------------------------

'  Declare Sub Bip_bip()
'  Declare Sub __lcd()
  Declare Sub __uart()
  Declare Sub __uart_()
'  Declare Sub ___uart(__uart As String)       '    
  Declare Sub Print_(__uart As String * 20)

'------          ----
  _lcd = 1
  _lcd = 1
  _ = 1
'--------------------       --------------------
'  Enable Timer1
'  Enable Timer2
  Enable Urxc       '        UART
'  Enable Udre                                     '      UART
'  Enable Utxc                                     '       UART
'--------------------       ------------------------
  Enable Interrupts
'-------------------------------------------------------------------------------------------
'=================================================
'------------------------------     -----------------------------------------
  Do
  __:
'----------------------------------

'------------     USART  3    -----------
'     Incr Ocr2
'     Incr Ocr1al
'     Decr Ocr1bl
'-------------------------------------------------------------------------------------------

     If ____uart = 1 Then

         If Mid(__uart , 1 , 3) = "cls" Then
                                                                            Cls
         Elseif Mid(__uart , 1 , 8) = " 1" Then
                                                                                           _lcd = 1
         Elseif Mid(__uart , 1 , 8) = " 2" Then
                                                                                           _lcd = 2
         Elseif Mid(__uart , 1 , 8) = " 3" Then
                                                                                           _lcd = 3
         Elseif Mid(__uart , 1 , 8) = " 4" Then
                                                                                           _lcd = 4
           Else
               ' _lcd = 1 : _lcd = 1     '      LCD
                Locate _lcd , _lcd       '    
                Lcd Spc(20)       '  20  (   LCD    )
                _lcd = __uart
                Lcd_print _lcd       '    LCD

                Print_ _lcd       '    "_lcd"  USART    "Print_"
         End If

         __uart = ""       '     USART
         ____uart = 0       '     ,    
     End If

'     Waitms 50
'-----------------------
    _:
      Power Idle       '    ,  
'      Power Powersave
'----------------------------------------
  Goto __
  Loop
 End
'=================================================

'                                     

'=================================================

'  $include "\     .bas"
'  $include "\     .bas"
'  $include "\     .bas"

'=================================================

'                                         

'=================================================


'=================================================
  Sub Print_(byval __uart As String * 20)
'-------------------------------------------------------------------------------------------
    __uart = __uart       ' __uart
    Enable Udre
'-------------------------------------------------------------------------------------------
  End Sub
'=================================================


'=================================================
  __uart_:
'   1  = 63      1    USART 4800
'   1  = 6,3476      18.432    USART 57600
'-------------------------------------------------------------------------------------------
'  
    '__ = Mid(__uart , _ , 1 )       '   1          = 38 
    '___ = Asc(__)     '         = 8 

'  
    ___ = __uart_(_)

    If ___ = 0 Then       '   ,                = 6 
                                                              Udr = 13       '  "Enter" ( )
                                                              Disable Udre       '      UART
                                                              _ = 1       '         USART
                                                              __uart = ""       '   __uart
                                                              __uart_ = 1       '  ,   ,    USART    -   
                                                              Goto ___uart_       '    
    End If

    Incr _       '  , -      = 7 

    Udr = ___       '        = 7 

'-------------------------------------------------------------------------------------------
  ___uart_:
  Return
'=================================================


'=================================================
  __uart:       '   1  = 46 
'-------------------------------------------------------------------------------------------
    ___uart = Udr       '     USART

    If ___uart <> 13 Then       ' ,      "Enter"
                                                                   __uart = __uart + Chr(___uart)       '  ,        USART 
                                                                   Incr __       '    
        Else
               ____uart = 1       '    "Enter",     1. "Enter"-  
    End If
'-------------------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
  __uart_:
'-------------------------------------------------------------------------------------------
    __uart_ = 1
'-------------------------------------------------------------------------------------------
  Return
'=================================================


'    c UART
'=================================================
'Sub ___uart(__uart As String)
'-------------------------------------------------------------------------------------------

'__uart = ""

'Do

' __ = Inkey()       '      ASCII

' Select Case __

'  Case 0 :
'              Exit Do       '    -   

'  Case 10 :
'                If __uart <> "" Then Exit Do       ' ,    

'  Case Else :
'                   If __ > 31 Then __uart = __uart + Chr(__)       ' 

' End Select

'Loop
'-------------------------------------------------------------------------------------------
'End Sub
'=================================================


'=================================================
'=================================================
'=================================================
'=================================================
'=================================================
'-----------       LCD HD44780  ---------
'=================================================
  Sub Lcd_print(byval _lcd_print As String * 20)
'-------------------------------------------------------------------------------------------
'   Local  As Integer , _lcd_print As Integer
'   Local _ As Byte , __lcd As Byte
'   Local _lcd As String * 1 ,  As String * 1 ', __lcd As String * 20
'-------------------------------------------------------------------------------------------
     = Len(_lcd_print) : If  = 0 Then Exit Sub

    __lcd = ""

    For _lcd_print = 1 To 
       = Mid(_lcd_print , _lcd_print , 1)
      _ = Asc()
      __lcd = Lookup(_ , Cp1251_to_lcd_hd44780)
      _lcd = Chr(__lcd)
      __lcd = __lcd + _lcd
    Next _lcd_print

    Locate _lcd , _lcd
    Lcd __lcd
'-------------------------------------------------------------------------------------------
  End Sub
'=================================================

'**********************************************************************************************************************
'************            Cp1251    LCD        *************
'**********************************************************************************************************************
'-------------------------------------------------------------------------------------------
  Cp1251_to_lcd_hd44780:
'-------------------------------------------------------------------------------------------
'-----------------------------------------     128     -------------------------------------------------------------------------------------------------
'------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    Data &H00 , &H01 , &H02 , &H03 , &H04 , &H05 , &H06 , &H07 , &H08 , &H09 , &H0A , &H0B , &H0C , &H0D , &H0E , &H0F
    Data &H10 , &H11 , &H12 , &H13 , &H14 , &H15 , &H16 , &H17 , &H18 , &H19 , &H1A , &H1B , &H1C , &H1D , &H1E , &H1F
    Data &H20 , &H21 , &H22 , &H23 , &H24 , &H25 , &H26 , &H27 , &H28 , &H29 , &H2A , &H2B , &H2C , &H2D , &H2E , &H2F
    Data &H30 , &H31 , &H32 , &H33 , &H34 , &H35 , &H36 , &H37 , &H38 , &H39 , &H3A , &H3B , &H3C , &H3D , &H3E , &H3F
    Data &H40 , &H41 , &H42 , &H43 , &H44 , &H45 , &H46 , &H47 , &H48 , &H49 , &H4A , &H4B , &H4C , &H4D , &H4E , &H4F
    Data &H50 , &H51 , &H52 , &H53 , &H54 , &H55 , &H56 , &H57 , &H58 , &H59 , &H5A , &H5B , &H20 , &H5D , &H5E , &H5F
    Data &H60 , &H61 , &H62 , &H63 , &H64 , &H65 , &H66 , &H67 , &H68 , &H69 , &H6A , &H6B , &H6C , &H6D , &H6E , &H6F
    Data &H70 , &H71 , &H72 , &H73 , &H74 , &H75 , &H76 , &H77 , &H78 , &H79 , &H7A , &H5B , &H20 , &H5D , &HE9 , &H7F
'------------------------------------------------------------------------------------------------------------------------------------------------------------------------
'-----------------------------------------     128     -------------------------------------------------------------------------------------------------
'------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    Data &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20
    Data &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20 , &H20
    Data &HCB , &H20 , &H49 , &H69 , &H04 , &H20 , &HFE , &HEF , &HA2 , &HCC , &H00 , &HC9 , &H20 , &H20 , &H20 , &H02
    Data &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &HB5 , &H4E , &H00 , &H00 , &H00 , &H00 , &H00 , &H00
    Data &H41 , &HA0 , &H42 , &HA1 , &HE0 , &H45 , &HA3 , &HA4 , &HA5 , &HA6 , &H4B , &HA7 , &H4D , &H48 , &H4F , &HA8
    Data &H50 , &H43 , &H54 , &HA9 , &HAA , &H58 , &HE1 , &HAB , &HAC , &HE2 , &HAD , &HAE , &H62 , &HAF , &HB0 , &HB1
    Data &H61 , &HB2 , &HB3 , &HB4 , &HE3 , &H65 , &HB6 , &HB7 , &HB8 , &HB9 , &HBA , &HBB , &HBC , &HBD , &H6F , &HBE
    Data &H70 , &H63 , &HBF , &H79 , &HE4 , &H78 , &HE5 , &HC0 , &HC1 , &HE6 , &HC2 , &HC3 , &HC4 , &HC5 , &HC6 , &HC7
'------------------------------------------------------------------------------------------------------------------------------------------------------------------------
'**********************************************************************************************************************
'-------------------------------------------------------------------------------------------
'-----------------------------------------     128     --------------------
'-------------------------------------------------------------------------------------------
'    Data " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " "
'    Data " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " "
'    Data " " , "!" , " " , "#" , "$" , "%" , "&" , "'" , "(" , ")" , "*" , "+" , "," , "-" , "." , "/"
'    Data "0" , "1" , "2" , "3" , "4" , "5" , "6" , "7" , "8" , "9" , ":" , ";" , "<" , "=" , ">" , "?"
'    Data "@" , "A" , "B" , "C" , "D" , "E" , "F" , "G" , "H" , "I" , "J" , "K" , "L" , "M" , "N" , "O"
'    Data "P" , "Q" , "R" , "S" , "T" , "U" , "V" , "W" , "X" , "Y" , "Z" , "[" , "\" , "]" , "^" , "_"
'    Data "`" , "a" , "b" , "c" , "d" , "e" , "f" , "g" , "h" , "i" , "j" , "k" , "l" , "m" , "n" , "o"
'    Data "p" , "q" , "r" , "s" , "t" , "u" , "v" , "w" , "x" , "y" , "z" , "{" , "|" , "}" , "~" , ""
'-------------------------------------------------------------------------------------------
'-----------------------------------------     128     --------------------
'-------------------------------------------------------------------------------------------
'    Data " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " "
'    Data " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " " , " "
'    Data " " , " " , " " , " " , " " , " " , " " , " " , "" , " " , " " , " " , " " , " " , " " , " "
'    Data " " , " " , " " , " " , " " , " " , " " , " " , "" , " " , " " , " " , " " , " " , " " , " "
'    Data "A" , "" , "B" , "" , "" , "E" , "" , "" , "" , "" , "K" , "" , "M" , "H" , "O" , ""
'    Data "P" , "C" , "T" , "" , "" , "X" , "" , "" , "" , "" , "" , "" , "b" , "" , "" , ""
'    Data "a" , "" , "" , "" , "" , "e" , "" , "" , "" , "" , "" , "" , "" , "" , "o" , ""
'    Data "p" , "c" , "" , "y" , "" , "x" , "" , "" , "" , "" , "" , "" , "" , "" , "" , ""
'-------------------------------------------------------------------------------------------
'****************************************************************