'-------------------------------------------------------------------------------------------

'                   USART  Bascom

'                                            

'-------------------------------------------------------------------------------------------

'----------------    ( )  --------------

'  $regfile = "m48def.dat"       ' Atmega48A
'  Const Used_controller = 48       '  

  $regfile = "m8def.dat"       ' Atmega8A
  Const Used_controller = 8       '  

'  $regfile = "m88def.dat"       ' Atmega88A
'  Const Used_controller = 88       '  

'  $regfile = "m168def.dat"       ' Atmega168A
'  Const Used_controller = 168       '  

'  $regfile = "m328pdef.dat"       ' Atmega328P
'  Const Used_controller = 328       '  

'-------------------       ------------------------

  Const Speed_usart = 48       '  - USART 
  Const Frequency_crystal = 18       '   

'--------------------------      ------------------------------

  $framesize = 32
  $hwstack = 40
  $swstack = 16

'---------------------------      --------------------------------------

#if Frequency_crystal = 1       ' 1 
  $crystal = 1000000       ' 1 
#endif

#if Frequency_crystal = 1.8       ' 1.8432 
  $crystal = 1843200       ' 1.8432 
#endif

#if Frequency_crystal = 2       ' 2 
  $crystal = 2000000       ' 2 
#endif

#if Frequency_crystal = 3       ' 3.6864 
  $crystal = 3686400       ' 3.6864 
#endif

#if Frequency_crystal = 4       ' 4 
  $crystal = 4000000       ' 4 
#endif

#if Frequency_crystal = 7       ' 7.3728 
  $crystal = 7372800       ' 7.3728 
#endif

#if Frequency_crystal = 8       ' 8 
  $crystal = 8000000       ' 8 
#endif

#if Frequency_crystal = 14       ' 14.7456 
  $crystal = 14745600       ' 14.7456 
#endif

#if Frequency_crystal = 16       ' 16 
  $crystal = 16000000       ' 16 
#endif

#if Frequency_crystal = 18       ' 18.432 
  $crystal = 18432000       ' 18.432 
#endif

'--------------------   - USART   ----------------------

#if Speed_usart = 12       ' 1200
  $baud = 1200       ' 1200
#endif

#if Speed_usart = 24       ' 2400
  $baud = 2400       ' 2400
#endif

#if Speed_usart = 48       ' 4800
  $baud = 4800       ' 4800
#endif

#if Speed_usart = 96       ' 9600
  $baud = 9600       ' 9600
#endif

#if Speed_usart = 19       ' 19200
  $baud = 19200       ' 19200
#endif

#if Speed_usart = 38       ' 38400
  $baud = 38400       ' 38400
#endif

#if Speed_usart = 57       ' 57600
  $baud = 57600       ' 57600
#endif

#if Speed_usart = 115      ' 115200
  $baud = 115200       ' 115200
#endif

#if Speed_usart = 230       ' 230400
  $baud = 230400       ' 230400
#endif

'----------------------------   USART  --------------------------------------

'  Config Com1 = 4800 , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0
  Config Pind.0 = Input       '   RxD,  USART
  Config Pind.1 = Output       '   TxD,  USART

  On Urxc __uart       '           UART
  On Udre __uart_       '            UART
'  On Urxc __uart_       '           UART
'  On Utxc __uart_       '           UART

'-----------------------     --------------------------------

'  Dim _usart As String * 20
'  Dim __usart As String * 30
'  Dim __usart As String * 20

'  Dim __usart_byte As Byte

'  Print "  USART"
'-----------------------     --------------------------------
  Dim __uart As Byte
  Dim _ As Byte
  Dim __uart_ As Byte
  Dim __uart As String * 20
  Dim __ As String * 1
  Dim __uart As String * 20
  Dim ___ As Byte
  Dim ___uart As Byte
  Dim __ As Byte
  Dim __uart_ As Byte
  Dim ____uart As Byte
  Dim __uart As String * 20
  Dim __uart_(21) As Byte At __uart Overlay       '    

'-----------------------     -----------------------------

'  Declare Sub Bip_bip()
'  Declare Sub __lcd()
'  Declare Sub __uart()
'  Declare Sub __uart_()
'  Declare Sub ___uart(__uart As String)       '    
  Declare Sub Print_(__uart As String * 20)

'------          ----

'  _lcd = 1
'  _lcd = 1
  _ = 1

'--------------------       --------------------
'  Enable Timer1
'  Enable Timer2
  Enable Urxc       '        UART
'  Enable Udre                                     '      UART
'  Enable Utxc                                     '       UART
'--------------------       ------------------------
  Enable Interrupts
'-------------------------------------------------------------------------------------------
'=================================================
'------------------------------     -----------------------------------------
  Do
nop



    If ____uart = 1 Then
        __uart = Mid(__uart , 1 , 20)

'        __uart = 2
        If __uart = Lookupstr(2 , _usart) Then
'            __uart = 1
            __uart = Lookupstr(1 , _usart)
            Print_ __uart

        End If

        __uart = Lookupstr(0 , _usart)
        ____uart = 0
    End If



'    Waitms 1



nop
  Loop
 End
'=================================================

'                                     

'=================================================

'  $include "\     .bas"
'  $include "\     .bas"
'  $include "\     .bas"

'=================================================

'                                         

'=================================================

'=================================================
  Sub Print_(byval __uart As String * 20)
'-------------------------------------------------------------------------------------------
    __uart = __uart       ' __uart
    Enable Udre
'-------------------------------------------------------------------------------------------
  End Sub
'=================================================


'=================================================
  __uart_:
'   1  = 63      1    USART 4800
'   1  = 6,3476      18.432    USART 57600
'-------------------------------------------------------------------------------------------

'    __ = Mid(__uart , _ , 1 )       '   1          = 38 
'    ___ = Asc(__)       '         = 8 

'------------------------------------------------

    ___ = __uart_(_)

'------------------------------------------------

    If ___ = 0 Then       '   ,                = 6 
        Udr = 13       '  "Enter" ( )
        Disable Udre       '      UART
        _ = 1       '         USART
        __uart = ""       '   __uart
        __uart_ = 1       '  ,   ,    USART    -   
        Goto ___uart_       '    
    End If

    Incr _       '  , -      = 7 

    Udr = ___       '        = 7 

'-------------------------------------------------------------------------------------------
  ___uart_:
  Return
'=================================================


'=================================================
  __uart:       '   1  = 46 
'-------------------------------------------------------------------------------------------
    ___uart = Udr       '     USART

    If ___uart <> 13 Then       ' ,      "Enter"
        __uart = __uart + Chr(___uart)       '  ,        USART 
        Incr __       '    
      Else
        ____uart = 1       '    "Enter",     1. "Enter"-  
    End If
'-------------------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
  _usart:
'-------------------------------------------------------------------------------------------
    Data ""
    Data "ok"
    Data "Test  connect  USART"
    Data "  USART"
'=================================================









'=================================================
'  __uart:       '   1  = 46 
'-------------------------------------------------------------------------------------------
'    Inputhex __usart_byte

'    Input __usart
'-------------------------------------------------------------------------------------------
'  Return
'=================================================